---
stages:
  - lint
  - build


.common_python:
  image: python:3.10
  variables:
    # This is the directory in the image that is used
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/api_example_app_pip"
  cache:
    key:
      files:
         - api_example_app/requirements.txt
         - api_example_app/requirements-dev.txt
      prefix: api_example_app-python
    paths:
      - .cache/api_example_app_pip
      - api_example_app_venv/
  before_script:
    - python -V
    - pip install virtualenv
    - python -m venv api_example_app_venv
    - source api_example_app_venv/bin/activate
    - python -m pip install --upgrade pip
    - pip install -r api_example_app/requirements.txt -r api_example_app/requirements-dev.txt


lint:api_example_app:
  extends: .common_python
  stage: lint
  script:
    - cd $CI_PROJECT_DIR/api_example_app
    - black --check app.py
    - pylint --fail-under 5 app.py
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event" || $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      changes:
        - api_example_app/**/*
        - .gitlab-ci.yml


build:api-example:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:v1.9.0-debug
    entrypoint: [""]
  script:
    - /kaniko/executor --single-snapshot
      --context "${CI_PROJECT_DIR}/api_example_app"
      --dockerfile "${CI_PROJECT_DIR}/api_example_app/Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA}"
      --destination "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}"
    - echo -e "Pushed Images:\n${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}\n${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA}"
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event" || $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      changes:
        - api_example_app/**/*
        - .gitlab-ci.yml
